// Copyright (c) 2008, NTT DATA Corporation.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

using System;
using System.Collections.Generic;
using System.Text;
using TERASOLUNA.Fw.Common.BLogic;
using TERASOLUNA.Fw.Client;

namespace TERASOLUNA.Fw.ClientUT.CoordinatorTestData
{
    public class Coordinator_IBLogicImpl09 : IBLogic, ICancelable
    {
        private bool _isCalledExecute = false;
        private bool _isCancelled = false;
        private BLogicParam _executeBLogicParam = null;

        public bool IsCalledExecute
        {
            get { return _isCalledExecute; }
        }

        public BLogicParam ExecuteBLogicParam
        {
            get { return _executeBLogicParam; }
        }

        public BLogicResult Execute(BLogicParam param)
        {
            _isCalledExecute = true;
            _executeBLogicParam = param;
            BLogicResult result = new BLogicResult();
            result.ResultString = BLogicResult.SUCCESS;
            result.ResultData = new Coordinator_DataSetStub04();

            return result;
        }

        public bool Cancelled
        {
            get
            {
                return _isCancelled;
            }
            set
            {
                throw new NotSupportedException();
            }
        }

        public void Cancel()
        {
            _isCancelled = true;
        }
    }
}
